'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = authenticate;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function authenticate() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  return function (hook) {
    options = Object.assign({
      telegramIdField: 'telegramId',
      service: 'users'
    }, hook.app.get('authentication'), options);
    if (hook.type !== 'before') {
      throw new Error('The telegram \'authenticate\' hook should only be used as a \'before\' hook.');
    }
    if (!options.service) {
      throw new Error('The telegram \'authenticate\' hook requires an user service.');
    }
    if (hook.params.telegram) {
      var id = hook.params.message.from.id;
      return hook.app.service(options.service).find({
        query: _defineProperty({}, options.telegramIdField, id),
        paginate: false
      }).then(function (data) {
        if (data.length) {
          hook.params = Object.assign({ authenticated: true }, hook.params, { user: data[0] });
        }
        return hook;
      });
    }
    return hook;
  };
}
module.exports = exports['default'];