'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isBotCommand;

var _feathersErrors = require('feathers-errors');

var _feathersErrors2 = _interopRequireDefault(_feathersErrors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isBotCommand() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  return function (hook) {
    if (!hook.params.telegram || !hook.params.message) throw new _feathersErrors2.default.MethodNotAllowed('This is not a telegram message.');
    var message = hook.params.message;
    return message.text && message.text.indexOf('/') === 0;
  };
}
module.exports = exports['default'];