'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isChatType;

var _feathersErrors = require('feathers-errors');

var _feathersErrors2 = _interopRequireDefault(_feathersErrors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isChatType() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  return function (hook) {
    options = Object.assign({
      type: '',
      service: 'chats'
    }, options);
    if (hook.params.telegram && hook.params.message) {
      var message = hook.params.message;
      return message.chat.type == options.type;
    } else if (options.service) {
      var service = hook.app.service(options.service);
      return service.get(hook.id).then(function (chat) {
        return chat.type == options.type;
      });
    }
    return hook;
  };
}
module.exports = exports['default'];