'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = restrictToTelegram;

var _feathersErrors = require('feathers-errors');

var _feathersErrors2 = _interopRequireDefault(_feathersErrors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function restrictToTelegram() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  return function (hook) {
    if (!hook.params.telegram) {
      throw new _feathersErrors2.default.Forbidden('You must perform this action through the Telegram bot.');
    }
    return hook;
  };
}
module.exports = exports['default'];