'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = init;

var _nodeTelegramBotApi = require('node-telegram-bot-api');

var _nodeTelegramBotApi2 = _interopRequireDefault(_nodeTelegramBotApi);

var _hooks = require('./hooks');

var _hooks2 = _interopRequireDefault(_hooks);

var _message = require('./message');

var _message2 = _interopRequireDefault(_message);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function init() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  return function telegramBot() {
    var app = this;
    var _super = app.setup;
    var options = Object.assign({}, app.get('telegram') || {}, config);
    app.set('telegram', options);
    if (app.telegram) {
      throw new Error('You have already registered a Telegram Bot.');
    }
    if (!options.token) {
      throw new Error('You must provide a token for your bot.');
    }
    app.telegram = new _nodeTelegramBotApi2.default(options.token, { polling: true });
    console.log('initializing');
    app.setup = function () {
      var result = _super.apply(this, arguments);
      return result;
    };
  };
}

Object.assign(init, {
  hooks: _hooks2.default,
  Message: _message2.default
});
module.exports = exports['default'];